using HarmonyLib;
using Steamworks;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using TMPro;
using UnityEngine;
using UnityEngine.UI;
using Newtonsoft.Json;
using System.Reflection;
using System.Threading.Tasks;
using RaftModLoader;
using HMLLibrary;

public class TeKAdminTool : Mod
{
    // DEBUG FEATURE! SHOULD ALWAYS BE TRUE!
    public static bool DisableHostPermissions = true;

    static AssetBundle asset;
    static Canvas menu;
    public static bool isShown;
    static string CurrentTab;
    static GameObject rankEntry;
    static GameObject banEntry;
    static GameObject playerEntry;
    static GameObject logEntry;
    public static Raft_Network network;
    public static string Prefix = "<color=#42a7f5>[TeK's Admin Tool]</color> ";
    public static string playersmenu_searchterm;
    public static string permissionsmenu_searchterm;
    public static string bansmenu_searchterm;
    public static string logsmenu_searchterm;

    Harmony HARMONY_INSTANCE;
    string HARMONY_ID = "fr.tekgamer.tekadmintool";

    static GameObject NoHostMessage;

    public static Transform mainRanks;
    public static Transform defaultRank;
    public static Transform rank1;
    public static Transform rank2;
    public static Transform rank3;

    public static List<string> logs = new List<string>();

    public static TATDatabase database = new TATDatabase();

    public IEnumerator Start()
    {
        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("tekadmintool.assets"));
        yield return request;
        asset = request.assetBundle;

        HARMONY_INSTANCE = new Harmony(HARMONY_ID);
        HARMONY_INSTANCE.PatchAll(Assembly.GetExecutingAssembly());

        menu = Instantiate(asset.LoadAsset<GameObject>("TeKAdminToolCanvas"), transform).GetComponent<Canvas>();

        mainRanks = menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Content");
        defaultRank = mainRanks.Find("DefaultRank").Find("Content");
        rank1 = mainRanks.Find("Rank1").Find("Content");
        rank2 = mainRanks.Find("Rank2").Find("Content");
        rank3 = mainRanks.Find("Rank3").Find("Content");

        NoHostMessage = menu.transform.Find("Background").Find("NoHost").gameObject;
        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
        menu.transform.Find("Background").Find("Tabs").Find("Players").GetComponent<Button>().onClick.AddListener(() => SelectTab("Players"));
        menu.transform.Find("Background").Find("Menus").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { playersmenu_searchterm = t; InitPlayersTab(); });
        menu.transform.Find("Background").Find("Tabs").Find("Permissions").GetComponent<Button>().onClick.AddListener(() => SelectTab("Permissions"));
        menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { permissionsmenu_searchterm = t; InitPermissionsTab(); });
        menu.transform.Find("Background").Find("Tabs").Find("Bans").GetComponent<Button>().onClick.AddListener(() => SelectTab("Bans"));
        menu.transform.Find("Background").Find("Menus").Find("Bans").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { bansmenu_searchterm = t; InitBansTab(); });
        menu.transform.Find("Background").Find("Tabs").Find("Logs").GetComponent<Button>().onClick.AddListener(() => SelectTab("Logs"));
        menu.transform.Find("Background").Find("Menus").Find("Logs").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { logsmenu_searchterm = t; InitLogsTab(); });
        playerEntry = asset.LoadAsset<GameObject>("PlayerEntry");
        rankEntry = asset.LoadAsset<GameObject>("RankEntry");
        banEntry = asset.LoadAsset<GameObject>("BanEntry");
        logEntry = asset.LoadAsset<GameObject>("LogEntry");
        menu.transform.Find("Background").Find("Topbar").Find("CloseButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            isShown = false;
            menu.GetComponent<CanvasGroup>().alpha = 0;
            menu.GetComponent<CanvasGroup>().interactable = false;
            menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
            RAPI.ToggleCursor(isShown);
        });
        network = ComponentManager<Raft_Network>.Value;

        if (SaveAndLoad.CurrentGameFileName != null && !LoadSceneManager.IsGameSceneLoaded)
        {
            TryLoadDatabase();
        }

        InitPermissionsTabRankButtons();

        SelectTab("Players");
        Log("Mod Successfully Loaded!");
    }

    [ConsoleCommand(name: "tatmenu", docs: "Open the <b>TeK'sAdminTool</b> menu.")]
    public static void ToggleMenu()
    {
        if (RConsole.isOpen) { RConsole.isOpen = false; }
        OpenMenuLate();
    }

    public static bool IsUserBanned(CSteamID steamID)
    {
        return database.bans.ContainsKey(steamID.m_SteamID);
    }

    public void InitPermissionsTabRankButtons()
    {
        if (!Raft_Network.IsHost) { return; };
        defaultRank.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.defaultRank.canPlaceBlocks = v;
            SaveDatabase();
        });

        defaultRank.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.defaultRank.canDestroyBlocks = v;
            SaveDatabase();
        });

        defaultRank.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.defaultRank.canPaintBlocks = v;
            SaveDatabase();
        });

        rank1.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank1.canPlaceBlocks = v;
            SaveDatabase();
        });

        rank1.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank1.canDestroyBlocks = v;
            SaveDatabase();
        });

        rank1.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank1.canPaintBlocks = v;
            SaveDatabase();
        });

        rank2.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank2.canPlaceBlocks = v;
            SaveDatabase();
        });

        rank2.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank2.canDestroyBlocks = v;
            SaveDatabase();
        });

        rank2.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank2.canPaintBlocks = v;
            SaveDatabase();
        });

        rank3.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank3.canPlaceBlocks = v;
            SaveDatabase();
        });

        rank3.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank3.canDestroyBlocks = v;
            SaveDatabase();
        });

        rank3.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().onValueChanged.AddListener((v) =>
        {
            database.rank3.canPaintBlocks = v;
            SaveDatabase();
        });
    }

    public override void WorldEvent_WorldLoaded()
    {
        if (!Raft_Network.IsHost) { return; };
        logs.Clear();
        TryLoadDatabase();
    }

    public async static void TryLoadDatabase()
    {
        if (!Raft_Network.IsHost) { return; };
        if (!LoadSceneManager.IsGameSceneLoaded) { Log("Can't load world database in main menu!"); return; }
        while (SaveAndLoad.CurrentGameFileName == null) { await Task.Delay(1); }
        try
        {
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "TeKAdminTool"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "TeKAdminTool/TeK'sAdminTool"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "TeKAdminTool/TeK'sAdminTool/WorldSaves"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "TeKAdminTool/TeK'sAdminTool/WorldSaves/" + SaveAndLoad.CurrentGameFileName));
            string filename = Path.Combine(HLib.path_modsFolder, "TeKAdminTool/TeK'sAdminTool/WorldSaves/" + SaveAndLoad.CurrentGameFileName + "/database.json");
            if (File.Exists(filename))
            {
                TATDatabase db = JsonConvert.DeserializeObject<TATDatabase>(File.ReadAllText(filename));
                if (database != db)
                {
                    database = db;

                    defaultRank.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().isOn = database.defaultRank.canPlaceBlocks;
                    defaultRank.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().isOn = database.defaultRank.canDestroyBlocks;
                    defaultRank.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().isOn = database.defaultRank.canPaintBlocks;
                    rank1.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().isOn = database.rank1.canPlaceBlocks;
                    rank1.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().isOn = database.rank1.canDestroyBlocks;
                    rank1.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().isOn = database.rank1.canPaintBlocks;
                    rank2.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().isOn = database.rank2.canPlaceBlocks;
                    rank2.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().isOn = database.rank2.canDestroyBlocks;
                    rank2.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().isOn = database.rank2.canPaintBlocks;
                    rank3.Find("CanPlaceBlocks").GetComponentInChildren<Toggle>().isOn = database.rank3.canPlaceBlocks;
                    rank3.Find("CanDestroyBlocks").GetComponentInChildren<Toggle>().isOn = database.rank3.canDestroyBlocks;
                    rank3.Find("CanPaintBlocks").GetComponentInChildren<Toggle>().isOn = database.rank3.canPaintBlocks;

                    Log("<color=green>Database Successfully Loaded!</color>");
                }
            }
            else
            {
                Log("<color=red>No Database has been found for this world! Creating one...</color>");
                File.WriteAllText(filename, JsonConvert.SerializeObject(database));
                Log("<color=green>Database Successfully Created!</color>");
            }
        }
        catch (Exception e)
        {
            LogError("An error occured while loading the database of this world!\n" + e.ToString());
        }
        menu.transform.Find("Background").Find("CurrentWorldDatabase").GetComponent<TextMeshProUGUI>().text = "Current World Database :\n" + SaveAndLoad.CurrentGameFileName;
    }

    public static async void SaveDatabase()
    {
        if (!Raft_Network.IsHost) { return; };
        if (!LoadSceneManager.IsGameSceneLoaded) { Log("Can't save world database in main menu!"); return; }
        while (SaveAndLoad.CurrentGameFileName == null) { await Task.Delay(1); }
        try
        {
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "../TeKAdminTool"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "../TeKAdminTool/TeK'sAdminTool"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "../TeKAdminTool/TeK'sAdminTool/WorldSaves"));
            Directory.CreateDirectory(Path.Combine(HLib.path_modsFolder, "../TeKAdminTool/TeK'sAdminTool/WorldSaves/" + SaveAndLoad.CurrentGameFileName));
            string filename = Path.Combine(HLib.path_modsFolder, "../TeKAdminTool/TeK'sAdminTool/WorldSaves/" + SaveAndLoad.CurrentGameFileName + "/database.json");
            File.WriteAllText(filename, JsonConvert.SerializeObject(database, Formatting.Indented));
            menu.transform.Find("Background").Find("CurrentWorldDatabase").GetComponent<TextMeshProUGUI>().text = "Current World Database :\n" + SaveAndLoad.CurrentGameFileName;
        }
        catch (Exception e)
        {
            LogError("An error occured while saving the current world database!\n" + e.ToString());
        }
    }

    public async static void AddPlayer(CSteamID steamID)
    {
        if (!Raft_Network.IsHost) { return; };
        if (DisableHostPermissions && network.HostID == steamID) { return; }
        if (!DisableHostPermissions && network.HostID == steamID) { TryLoadDatabase(); }
        if (database.players.ContainsKey(steamID.m_SteamID))
        {
            Log("Found " + RAPI.GetUsernameFromSteamID(steamID) + " in the database!");
            return;
        }
        database.players.Add(steamID.m_SteamID, new TAT_PlayerData());
        Log("Added " + RAPI.GetUsernameFromSteamID(steamID) + " to the database!");
        SaveDatabase();
        int tries = 0;
        while (!network.remoteUsers.ContainsKey(steamID) && tries < 30)
        {
            tries++;
            await Task.Delay(1000);
            network.remoteUsers[steamID]._SendChatMessage("<color=#3a8cc7>:shield: THIS SERVER IS PROTECTED BY <b>TEK'S ADMIN TOOL</b>! :shield:</color>");
        }
    }

    public static void SelectTab(string name)
    {
        if (!Raft_Network.IsHost) { return; };
        CurrentTab = name;
        switch (name)
        {
            case "Players":
                playersmenu_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitPlayersTab();
                break;
            case "Permissions":
                permissionsmenu_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Players").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitPermissionsTab();
                break;
            case "Bans":
                bansmenu_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("Bans").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("Bans").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitBansTab();
                break;
            case "Logs":
                logsmenu_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("Logs").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("Logs").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitLogsTab();
                break;
        }
        foreach (Transform t in menu.transform.Find("Background").Find("Menus"))
        {
            t.gameObject.SetActive(t.transform.name == name);
        }
    }

    public static void InitPlayersTab()
    {
        if (!Raft_Network.IsHost) { return; };
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Players").Find("ScrollView").Find("Viewport").Find("Content");
        foreach (Transform child in content)
        {
            Destroy(child.gameObject);
        }
        int amount = 0;
        foreach (KeyValuePair<CSteamID, Network_Player> player in network.remoteUsers)
        {
            if (RAPI.GetUsernameFromSteamID(player.Key).ToLower().Contains(playersmenu_searchterm.ToLower()))
            {
                if (DisableHostPermissions && network.HostID == player.Key) { return; }
                amount++;
                GameObject entry = Instantiate(playerEntry, content);
                entry.transform.Find("Name").GetComponent<TextMeshProUGUI>().text = RAPI.GetUsernameFromSteamID(player.Key);
                entry.transform.Find("Rank").GetComponent<TextMeshProUGUI>().text = database.players[player.Key.m_SteamID].rank.ToString();
                entry.transform.Find("Actions").Find("Bring").GetComponent<Button>().onClick.AddListener(() => { BringUser(player.Key); });
                entry.transform.Find("Actions").Find("Goto").GetComponent<Button>().onClick.AddListener(() => { GotoUser(player.Key); });
                entry.transform.Find("Actions").Find("Kick").GetComponent<Button>().onClick.AddListener(() => { KickUser(player.Key); });
                entry.transform.Find("Actions").Find("Ban").GetComponent<Button>().onClick.AddListener(() => { BanUser(player.Key); });
            }
        }
        menu.transform.Find("Background").Find("Menus").Find("Players").Find("Nothing").gameObject.SetActive(amount == 0);
    }

    public static void InitPermissionsTab()
    {
        if (!Raft_Network.IsHost) { return; };
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Players").Find("ScrollView").Find("Viewport").Find("Content");
        foreach (Transform child in content)
        {
            Destroy(child.gameObject);
        }
        int amount = 0;
        foreach (KeyValuePair<CSteamID, Network_Player> player in network.remoteUsers)
        {
            if (RAPI.GetUsernameFromSteamID(player.Key).ToLower().Contains(permissionsmenu_searchterm.ToLower()))
            {
                if (DisableHostPermissions && network.HostID == player.Key) { return; }
                if (database.players.ContainsKey(player.Key.m_SteamID))
                {
                    amount++;
                    GameObject entry = Instantiate(rankEntry, content);
                    entry.transform.Find("Name").GetComponent<TextMeshProUGUI>().text = RAPI.GetUsernameFromSteamID(player.Key);
                    entry.transform.Find("Rank").GetComponent<TMP_Dropdown>().value = (int)database.players[player.Key.m_SteamID].rank;
                    entry.transform.Find("Rank").GetComponent<TMP_Dropdown>().onValueChanged.AddListener((value) =>
                    {
                        if (value != (int)database.players[player.Key.m_SteamID].rank)
                        {
                            database.players[player.Key.m_SteamID].rank = (Rank)value;
                            _BroadcastChatMessage("<color=#3ac73a><b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b> has set the rank of <b>" + RAPI.GetUsernameFromSteamID(player.Key) + "</b> to <b>" + ((Rank)value).ToString() + "</b></color>");
                            SaveDatabase();
                        }
                    });
                }
            }
        }
        menu.transform.Find("Background").Find("Menus").Find("Permissions").Find("Players").Find("Nothing").gameObject.SetActive(amount == 0);
    }

    public static void InitBansTab()
    {
        if (!Raft_Network.IsHost) { return; };
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Bans").Find("ScrollView").Find("Viewport").Find("Content");
        foreach (Transform child in content)
        {
            Destroy(child.gameObject);
        }
        int amount = 0;
        foreach (KeyValuePair<ulong, string> ban in database.bans)
        {
            if (ban.Value.ToLower().Contains(bansmenu_searchterm.ToLower()))
            {
                amount++;
                GameObject entry = Instantiate(banEntry, content);
                entry.transform.Find("Name").GetComponent<TextMeshProUGUI>().text = ban.Value;
                entry.transform.Find("Unban").GetComponent<Button>().onClick.AddListener(() => { UnbanUser(ban); });
            }
        }
        menu.transform.Find("Background").Find("Menus").Find("Bans").Find("Nothing").gameObject.SetActive(amount == 0);
    }

    public static void InitLogsTab()
    {
        if (!Raft_Network.IsHost) { return; };
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Logs").Find("ScrollView").Find("Viewport").Find("Content");
        foreach (Transform child in content)
        {
            Destroy(child.gameObject);
        }
        foreach (string log in logs)
        {
            if (log.ToLower().Contains(logsmenu_searchterm.ToLower()))
            {
                GameObject entry = Instantiate(logEntry, content);
                entry.transform.Find("Name").GetComponent<TextMeshProUGUI>().text = log;
            }
        }
    }

    public static void UnbanUser(KeyValuePair<ulong, string> ban)
    {
        if (!Raft_Network.IsHost) { return; };
        if (database.bans.ContainsKey(ban.Key))
        {
            database.bans.Remove(ban.Key);
            _BroadcastChatMessage("<color=#3ac73a><b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b> has unbanned <b>" + ban.Value + "</b>.</color>");
            SaveDatabase();
            SelectTab("Bans");
        }
    }

    public static void BringUser(CSteamID steamid)
    {
        if (!Raft_Network.IsHost) { return; };
        if (network.remoteUsers.ContainsKey(steamid))
        {
            Network_Player me = RAPI.GetLocalPlayer();
            Network_Player target = network.remoteUsers[steamid];
            Message_Teleport message2 = new Message_Teleport(Messages.Teleport, ComponentManager<Raft_Network>.Value.NetworkIDManager, target, me.transform.position + new Vector3(0, 1, 0));
            target.SendP2P(message2, EP2PSend.k_EP2PSendReliable, 0);

            _BroadcastChatMessage("<color=#42a7f5><b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b> has teleported <b>" + RAPI.GetUsernameFromSteamID(target.steamID) + "</b> to himself.</color>");
        }
    }

    public static void GotoUser(CSteamID steamid)
    {
        if (!Raft_Network.IsHost) { return; };
        if (network.remoteUsers.ContainsKey(steamid))
        {
            Network_Player me = RAPI.GetLocalPlayer();
            Network_Player target = network.remoteUsers[steamid];
            me.PersonController.SwitchControllerType(target.PersonController.controllerType);
            RAPI.GetLocalPlayer().transform.position = network.remoteUsers[steamid].transform.position + new Vector3(0, 1, 0);
            me.PlayerScript.MakeUnStuck();

            _BroadcastChatMessage("<color=#42a7f5><b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b> has teleported himself to <b>" + RAPI.GetUsernameFromSteamID(target.steamID) + "</b></color>");
        }
    }

    public static async void KickUser(CSteamID steamid)
    {
        if (!Raft_Network.IsHost) { return; };
        if (network.remoteUsers.ContainsKey(steamid))
        {
            Network_Player me = RAPI.GetLocalPlayer();
            Network_Player target = network.remoteUsers[steamid];

            for (int i = 0; i < 10; i++)
            {
                target._SendChatMessage("<color=#c73a3a>YOU HAVE BEEN KICKED FROM THE SERVER!</color>");
            }
            await Task.Delay(100);
            Message_DisconnectNotify message2 = new Message_DisconnectNotify(Messages.Disconnect_Notify, steamid, DisconnectReason.Timeout, false);
            network.RPC(message2, Target.All, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Session);
            await Task.Delay(100);
            SteamNetworking.CloseP2PChannelWithUser(steamid, 0);
            SteamNetworking.CloseP2PChannelWithUser(steamid, 1);
            SteamNetworking.CloseP2PSessionWithUser(steamid);

            _BroadcastChatMessage("<color=#c73a3a><b>" + RAPI.GetUsernameFromSteamID(target.steamID) + "</b> has been kicked by <b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b>!</color>");
            await Task.Delay(100);
            SelectTab("Players");
        }
    }

    public static async void BanUser(CSteamID steamid)
    {
        if (!Raft_Network.IsHost) { return; };
        if (network.remoteUsers.ContainsKey(steamid))
        {
            Network_Player me = RAPI.GetLocalPlayer();
            Network_Player target = network.remoteUsers[steamid];

            if (!database.bans.ContainsKey(target.steamID.m_SteamID))
            {
                database.bans.Add(target.steamID.m_SteamID, RAPI.GetUsernameFromSteamID(target.steamID));
                for (int i = 0; i < 10; i++)
                {
                    target._SendChatMessage("<color=#c73a3a>YOU HAVE BEEN PERMANENTLY BANNED FROM THE SERVER!</color>");
                }
                await Task.Delay(100);
                Message_DisconnectNotify message2 = new Message_DisconnectNotify(Messages.Disconnect_Notify, steamid, DisconnectReason.Timeout, false);
                network.RPC(message2, Target.All, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Session);
                await Task.Delay(100);
                SteamNetworking.CloseP2PChannelWithUser(steamid, 0);
                SteamNetworking.CloseP2PChannelWithUser(steamid, 1);
                SteamNetworking.CloseP2PSessionWithUser(steamid);

                _BroadcastChatMessage("<color=#c73a3a><b>" + RAPI.GetUsernameFromSteamID(target.steamID) + "</b> has been permanently banned by <b>" + RAPI.GetUsernameFromSteamID(RAPI.GetLocalPlayer().steamID) + "</b>!</color>");
                SaveDatabase();
                await Task.Delay(100);
                SelectTab("Players");
            }
        }
    }

    public static void AddLog(string text)
    {
        logs.Add(DateTime.Now.ToString("HH:mm") + " - " + text);
    }

    public async static void OpenMenuLate()
    {
        await Task.Delay(50);
        OpenMenu();
    }

    public static void OpenMenu()
    {
        if (!LoadSceneManager.IsGameSceneLoaded) { return; }
        SelectTab("Players");
        isShown = true;
        menu.GetComponent<CanvasGroup>().alpha = 1;
        menu.GetComponent<CanvasGroup>().interactable = true && Raft_Network.IsHost;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = true;
        RAPI.ToggleCursor(true);
    }

    public void Update()
    {
        if (!Raft_Network.IsHost) { return; };
        if (asset == null || menu == null) { return; }
        if (!LoadSceneManager.IsGameSceneLoaded)
        {
            if (isShown)
            {
                isShown = false;
                menu.GetComponent<CanvasGroup>().alpha = 0;
                menu.GetComponent<CanvasGroup>().interactable = false;
                menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
            }
            return;
        }
        NoHostMessage.SetActive(!Raft_Network.IsHost);
        if (isShown && Input.GetKeyDown(KeyCode.Escape))
        {
            SelectTab("Players");
            isShown = !isShown;
            menu.GetComponent<CanvasGroup>().alpha = isShown ? 1 : 0;
            menu.GetComponent<CanvasGroup>().interactable = isShown && Raft_Network.IsHost;
            menu.GetComponent<CanvasGroup>().blocksRaycasts = isShown;
            RAPI.ToggleCursor(isShown);
        }
    }

    public static RankData GetRankDataFromRank(Rank rank)
    {
        switch (rank)
        {
            case Rank.Default:
                return database.defaultRank;
            case Rank.Rank1:
                return database.rank1;
            case Rank.Rank2:
                return database.rank2;
            case Rank.Rank3:
                return database.rank3;
        }
        return database.defaultRank;
    }

    public void OnModUnload()
    {
        SaveDatabase();
        HARMONY_INSTANCE.UnpatchAll();
        if (asset)
        {
            asset.Unload(true);
        }
        Debug.Log("TeK's Admin Tool has been unloaded!");
        Destroy(gameObject);
    }

    public static void Log(object message)
    {
        if (!Raft_Network.IsHost) { return; };
        Debug.Log(Prefix + message);
    }

    public static void LogError(object message)
    {
        if (!Raft_Network.IsHost) { return; };
        Debug.LogError(Prefix + message);
    }

    public static void _BroadcastChatMessage(string message)
    {
        if (!Raft_Network.IsHost) { return; };
        ChatManager chatManager = ComponentManager<ChatManager>.Value;
        Raft_Network network = ComponentManager<Raft_Network>.Value;
        CSteamID csteamid = new CSteamID();
        Message_IngameChat nmessage = new Message_IngameChat(Messages.Ingame_Chat_Message, chatManager, csteamid, message);
        network.RPC(nmessage, Target.All, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Game);
    }
}

public static class _RPlayerExtentions
{
    public static void _SendChatMessage(this Network_Player player, string message)
    {
        if (!Raft_Network.IsHost) { return; };
        ChatManager chatManager = ComponentManager<ChatManager>.Value;
        Raft_Network network = ComponentManager<Raft_Network>.Value;
        CSteamID csteamid = new CSteamID();
        Message_IngameChat nmessage = new Message_IngameChat(Messages.Ingame_Chat_Message, chatManager, csteamid, message);
        network.SendP2P(player.steamID, nmessage, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Game);
    }
}

public class TATDatabase
{
    public Dictionary<ulong, TAT_PlayerData> players = new Dictionary<ulong, TAT_PlayerData>();
    public Dictionary<ulong, string> bans = new Dictionary<ulong, string>();
    public RankData defaultRank = new RankData(true, true, true);
    public RankData rank1 = new RankData(true, true, true);
    public RankData rank2 = new RankData(true, true, true);
    public RankData rank3 = new RankData(true, true, true);
}

public class RankData
{
    public bool canPlaceBlocks;
    public bool canDestroyBlocks;
    public bool canPaintBlocks;

    public RankData(bool canPlace, bool canDestroy, bool canPaint)
    {
        canPlaceBlocks = canPlace;
        canDestroyBlocks = canDestroy;
        canPaintBlocks = canPaint;
    }
}

public class TAT_PlayerData
{
    public Rank rank = Rank.Default;
}

public enum Rank
{
    Default,
    Rank1,
    Rank2,
    Rank3
}

[HarmonyPatch(typeof(Raft_Network))]
[HarmonyPatch("AddPlayer")]
[HarmonyPatch(new Type[] { typeof(CSteamID), typeof(RGD_Settings_Character) })]
class Patch_AddPlayer
{
    static void Postfix(CSteamID steamID, RGD_Settings_Character characterSettings)
    {
        if (!Raft_Network.IsHost) { return; };
        TeKAdminTool.AddPlayer(steamID);
    }
}

[HarmonyPatch(typeof(Raft_Network))]
[HarmonyPatch("CanUserJoinMe")]
class Patch_PreventJoiningWhileStarting
{
    static bool Prefix(Raft_Network __instance, ref InitiateResult __result, CSteamID remoteID, int appBuildID, string password)
    {
        if (!Raft_Network.IsHost) { return true; };
        if (TeKAdminTool.IsUserBanned(remoteID))
        {
            __result = (InitiateResult)666;
            return false;
        }
        return true;
    }
}

[HarmonyPatch(typeof(Network_Player))]
[HarmonyPatch("Deserialize")]
class Patch_RemoveBlock
{
    static bool Prefix(Network_Player __instance, Message_NetworkBehaviour msg, CSteamID remoteID)
    {
        if (!Raft_Network.IsHost) { return true; };
        if (msg.Type == Messages.Axe_RemoveBlock)
        {
            if (TeKAdminTool.GetRankDataFromRank(TeKAdminTool.database.players[remoteID.m_SteamID].rank).canDestroyBlocks)
            {
                try
                {
                    Message_BlockCreator_RemoveBlock _msg = msg as Message_BlockCreator_RemoveBlock;
                    TeKAdminTool.AddLog(RAPI.GetUsernameFromSteamID(remoteID) + " removed a block!");
                }
                catch { }
                return true;
            }
            else
            {
                ComponentManager<Raft_Network>.Value.remoteUsers[remoteID]._SendChatMessage(TeKAdminTool.Prefix + "<color=#c73a3a>You don't have the permission to break this block!</color>");
                return false;
            }
        }
        else if (msg.Type == Messages.PaintBlock)
        {
            if (TeKAdminTool.GetRankDataFromRank(TeKAdminTool.database.players[remoteID.m_SteamID].rank).canPaintBlocks)
            {
                try
                {
                    Message_PaintBlock _msg = msg as Message_PaintBlock;
                    Block block = BlockCreator.GetPlacedBlocks().Find((Block b) => b.ObjectIndex == _msg.boi);
                    if (block != null)
                    {
                        TeKAdminTool.AddLog(RAPI.GetUsernameFromSteamID(remoteID) + " painted block \"" + block.buildableItem.settings_Inventory.DisplayName + "\".");
                    }
                }
                catch { }
                return true;
            }
            else
            {
                ComponentManager<Raft_Network>.Value.remoteUsers[remoteID]._SendChatMessage(TeKAdminTool.Prefix + "<color=#c73a3a>You don't have the permission to paint this block!</color>");
                return false;
            }
        }
        return true;
    }
}

[HarmonyPatch(typeof(BlockCreator))]
[HarmonyPatch("Deserialize")]
class Patch_RemoveBlock_BlockCreator
{
    static bool Prefix(BlockCreator __instance, Message_NetworkBehaviour msg, CSteamID remoteID)
    {
        if (!Raft_Network.IsHost) { return true; };
        if (msg.Type == Messages.BlockCreator_PlaceBlock)
        {
            if (TeKAdminTool.GetRankDataFromRank(TeKAdminTool.database.players[remoteID.m_SteamID].rank).canPlaceBlocks)
            {
                try
                {
                    Message_BlockCreator_PlaceBlock _msg = msg as Message_BlockCreator_PlaceBlock;
                    TeKAdminTool.AddLog(RAPI.GetUsernameFromSteamID(remoteID) + " placed block \"" + ItemManager.GetItemByIndex(_msg.uniqueBlockIndex).settings_Inventory.DisplayName + "\".");
                }
                catch { }
                return true;
            }
            else
            {
                ComponentManager<Raft_Network>.Value.remoteUsers[remoteID]._SendChatMessage(TeKAdminTool.Prefix + "<color=#c73a3a>You don't have the permission to place this block!</color>");
                return false;
            }
        }
        else if (msg.Type == Messages.BlockCreator_RemoveBlock)
        {
            if (TeKAdminTool.GetRankDataFromRank(TeKAdminTool.database.players[remoteID.m_SteamID].rank).canDestroyBlocks)
            {
                try
                {
                    Message_BlockCreator_RemoveBlock _msg = msg as Message_BlockCreator_RemoveBlock;
                    Block block = BlockCreator.GetPlacedBlocks().Find((Block b) => b.ObjectIndex == _msg.blockObjectIndex);
                    if (block != null)
                    {
                        TeKAdminTool.AddLog(RAPI.GetUsernameFromSteamID(remoteID) + " removed block \"" + block.buildableItem.settings_Inventory.DisplayName + "\".");
                    }
                }
                catch { }
                return true;
            }
            else
            {
                ComponentManager<Raft_Network>.Value.remoteUsers[remoteID]._SendChatMessage(TeKAdminTool.Prefix + "<color=#c73a3a>You don't have the permission to remove this block!</color>");
                return false;
            }
        }
        return true;
    }
}

[HarmonyPatch(typeof(RChat))]
[HarmonyPatch("AddUITextMessage")]
[HarmonyPatch(new Type[] { typeof(string), typeof(CSteamID) })]
class Patch_HandleCommand2
{
    static bool Prefix(RChat __instance, string p_ChatMessage, CSteamID p_steamID)
    {
        if (!Raft_Network.IsHost) { return true; };
        if (p_ChatMessage.ToLower() == "!adminmenu" && p_steamID.m_SteamID == TeKAdminTool.network.HostID.m_SteamID)
        {
            ComponentManager<Raft_Network>.Value.remoteUsers[p_steamID]._SendChatMessage(TeKAdminTool.Prefix + " Admin Menu Successfully Opened!");
            TeKAdminTool.OpenMenuLate();
            return false;
        }
        return true;
    }
}